<template>
  <div class="app-container">
    <el-card class="box-card app-container">
      <el-row slot="header">
        <el-col :span="20">
          <h3>{{ title }}</h3>
        </el-col>
        <el-col :span="4">
          <el-button type="primary" class="fr" @click="submit">
            Guardar
          </el-button>
        </el-col>
      </el-row>
      <el-form class="form" ref="fields" :rules="rules" :model="fields" label-position="top">
        <el-row :gutter="20">
          <el-col :span="4">
            <el-form-item label="Fecha Entrega" prop="deliveryDate" :error="errors.deliveryDate">
              <el-date-picker
                v-model.trim="fields.deliveryDate"
                type="date"
                format="dd/MM/yyyy"
                placeholder="Fecha de Entrega">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="18">
            <el-form-item label="Cliente" prop="client" :error="errors.client">
              <el-row>
                <el-col :span="20">
                  <app-select-related class="inline" v-model="fields.client"
                                      @input="updateDiscount"
                                      placeholder="Nombre del cliente"
                                      searchFieldName="name"
                                      :service="clientsService"
                  />
                </el-col>
                <el-col :span="4">
                  <el-button type="primary"
                             @click="fetchLastOrder(fields.client)"
                             :disabled="lastOrderDisabled">
                    Último Pedido
                    <font-awesome-icon icon="search-plus" />
                  </el-button>
                </el-col>
              </el-row>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="4">
            <el-form-item prop="state" :error="errors.state">
              <template slot="label">
                Estado
                <el-popover placement="right" trigger="hover" width="400" >
                  <el-table size="mini" :data="statesDescription()">
                    <el-table-column width="100" prop="name" label="Estado" />
                    <el-table-column prop="description" label="Descripción" />
                  </el-table>
                  <font-awesome-icon slot="reference" icon="question-circle" />
                </el-popover>
              </template>
              <el-select v-model="fields.state"
                placeholder="Estado">
                <el-option
                  v-for="(state, idx) in orderStates"
                  :key="idx"
                  :label="$t(state)"
                  :value="state">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="Descuento (%)" prop="discount" :error="errors.discount">
              <el-input-number v-model.trim="fields.discount" :min="0" :max="100" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
        </el-row>

        <h3>Productos</h3>
        <app-items-table v-model="fields.items" :discount="fields.discount" />
      </el-form>
    </el-card>
  </div>
</template>

<script>
import api from "@/feathers";
import orderStates from "@/services/order-states";
import BaseForm from "@/common/base-form.mixin";
import AppSelectRelated from "@/common/select-related";
import AppItemsTable from "@/common/items-table";

export default {
  name: "user-form",
  mixins: [BaseForm],
  props: {
    id: { type: String, required: false, default: null }
  },
  components: {
    AppItemsTable,
    AppSelectRelated
  },
  data() {
    const rules = {
      deliveryDate: [
        {
          required: true,
          message: "Debe ingresar una fecha de entrega",
          trigger: "blur"
        }
      ],
      client: [
        { required: true, message: "Debe ingresar un cliente", trigger: "blur" }
      ],
      state: [
        {
          required: true,
          message: "Debe ingresar un estado para el pedido",
          trigger: "blur"
        }
      ],
      discount: [
        {
          type: "number",
          message: "Debe ingresar un valor numérico",
          trigger: "blur"
        }
      ]
    };

    return {
      title: "",
      rules,
      errors: {},
      fields: {
        items: []
      },
      filteredClients: [],
      orderStates: [],
      salesmen: []
    };
  },
  created() {
    this.initialize();
  },
  computed: {
    lastOrderDisabled() {
      return !this.fields.client;
    }
  },
  methods: {
    async initialize() {
      this.clientsService = api.service("clients");
      this.service = api.service("my-orders");

      const { fields, errors } = this.buildForm(this.rules);
      fields.discount = fields.discount || 0;
      fields.state = fields.state || orderStates.getDefault();
      fields.items = fields.items || [];
      this.fields = fields;
      this.errors = errors;

      this.orderStates = orderStates.getSalesmenStates();
      this.salesmen = await this.getSalesmen();

      if (this.id) {
        this.fields = await this.service.get(this.id);
        this.action = "update";
        this.title = `Actualizar Pedido`;
      } else {
        this.action = "create";
        this.title = "Nuevo Pedido";
      }
    },
    fetchLastOrder(clientId) {
      return this.$confirm(
        "Este proceso reemplazará los items del pedido por los del último realizado."
      )
        .then(async () => {
          const query = {
            client: clientId,
            $sort: { deliveryDate: -1 },
            $limit: 1,
            $select: "items"
          };
          if (this.fields._id) {
            query._id = { $ne: this.fields._id };
          }
          const {
            total,
            data: [order]
          } = await this.service.find({ query });
          if (total >= 1) {
            this.fields.items = order.items;
          } else {
            this.$message({
              type: "warning",
              message: "No se encontró pedido para este cliente"
            });
          }
        })
        .catch(() => {});
    },
    statesDescription() {
      return orderStates.getDescription();
    },
    async getSalesmen() {
      return await api.service("salesmen").find({ query: { $limit: -1 } });
    },
    async updateDiscount(clientId) {
      if (clientId) {
        const client = await this.clientsService.get(clientId);
        this.fields.discount = client.defaultDiscount;
      }
    }
  }
};
</script>

<style lang="scss">
.el-card {
  &__header {
    margin: 0;
    padding: 10px 20px 4px 20px;
    h3 {
      margin: 0;
      padding: 10px 0px;
    }
  }
}
</style>
